% ================================================
% Adaboost Experiment
%
% Typical time spent
% training time: 492.7825 seconds
% testing time: 236.9967seconds
% ================================================

clear all
tic % start timer
patch_size = [85 127];
negNamesTrain = dir('rand85_127\*.jpg'); % negative training images
negNamesTest = dir('headShoulder_neg85_127\*.jpg'); % negative testing images
negFolder = 'rand85_127';
posNamesTrain = dir('headShoulder_trainpos85_127\*.jpg'); % positive training images
posFolder = 'headShoulder_trainpos85_127\';
posNamesTest = dir('headShoulder_pos85_127\*.jpg'); % positive testing images

subsample = 2; % sub sample rate that weak classifiers go over
name1 = 'headShoulder';
frameworkName = 'adaboost';
numWeakClassifiers = 80;

% prepare training data: train weak classifiers from all gabor basis
% <lattice>: subsampled locations on the image patch
[featureBank targetPoints negPoints lattice targetResonse negResponse threshold] = prepareDataForAdaboost(subsample,posNamesTrain,negNamesTrain,posFolder,negFolder);
% save([name1 '.mat'],'targetPoints','negPoints','featureBank','targetResonse', 'lattice', 'negResponse', 'threshold');
% load([name1 '.mat'],'targetPoints','negPoints','featureBank','targetResonse', 'negResponse', 'threshold');

folderName = [frameworkName '_' name1]; % this is the output folder
% Adaboost training: select weak classifiers
[lambdas selectedFeatures] = modelPursuit(targetPoints, negPoints,featureBank, numWeakClassifiers,folderName);
displaySelectedFilters(lambdas,selectedFeatures,lattice,patch_size,folderName);
posFolder = 'headShoulder_pos85_127';
negFolder = 'headShoulder_neg85_127';
disp(['training time: ' num2str(toc) ' seconds']);
disp('Testing...');
tic % start timer
% prepare test data
%   calculate responses of selected features on testing images
[featureBank testPosPoints testNegPoints lattice] = prepareDataForAdaboostTest(subsample,posNamesTest,negNamesTest,posFolder,negFolder,threshold,selectedFeatures);
% test strong classifier
testModel2(lambdas,testPosPoints,testNegPoints,folderName);
disp(['testing time: ' num2str(toc) 'seconds']);
